#!/bin/env python
import time


def generateRandomAAFastaSequence():
    AA1 = "ACDEFGHIKLMNPQRSTVWY"

    import random

    length=random.randint(50,450)

    seq=">random sequence\n"

    while length>0:
        i=random.randint(0,len(AA1)-1)
        seq=seq+AA1[i]
        length-=1

    return seq


from bioMoby import MobyFASTA, MobyContent, Parameter
from SOAPpy import SOAPProxy

s=SOAPProxy("http://bioserv.rpbs.jussieu.fr/RPBS/cgi-bin/wsRessource.py")

#Parametres d'appel pour Blastpgp
pe=Parameter("e","5.0")
pm=Parameter("M","BLOSUM80")

mQueries={}

#Creation de 30 requetes aleatoires
for i in range(1,7):
    mQueries['query%s'%i]=[MobyFASTA(content=generateRandomAAFastaSequence()), pe, pm]

mc=MobyContent(mQueries)

r=s.Blastpgp(str(mc))

from bioMoby import MobyUnmarshaller

um=MobyUnmarshaller()

mc=um.loads(r)

#Active wait, if we receive a JOBSESSION id, wait and see...
while 'JOBSESSION' in mc.keys():
    time.sleep(60)
    r=s.Blastpgp(str(mc))
    mc=um.loads(r)

#Print the results
for query in mc.keys():
    print query+"="
    print mQueries[query][0].content
    print "result="
    print mc[query][0].content
